# Containerized Postprocessing

In the last section you learned how to execute your customized app via the EATS CLI. This section will show a useful feature for testing the more complex app modes of preprocessing and postprocessing.

If your app declares a preprocessing **and** a containerized postprocessing mode in its ead, you can use outputs of a previously completed preprocessing job directly as inputs for a containerized postprocessing job. You don't have to manually create complex and large input files from exported preprocessing job outputs.

The app to demontrate this feature can be found in the [Tutorial: Backend](tutorial_backend/postprocessing.md).
The complete source code of the app is available on [GitLab](https://gitlab.com/empaia/integration/sample-apps/-/tree/master/sample_apps/tutorial/_TA12_containerized_postprocessing/v3)

## Prepare App

First we need to build the docker image for the app:

```bash
cd sample-apps/sample_apps/tutorial/_TA12_containerized_postprocessing/v3/
docker build -t ta12 .
```

## Register App

The app used here does not need an App UI or any configuration:

```bash
eats apps register ead.json ta12 > app.env
# export APP_ID
export $(xargs < app.env)
```

## Register and Run Preprocessing Job

The job we want to register is a preprocessing job, therefore we must use `--job-mode preprocessing`. The directory containing the inputs `eats_inputs` must contain the file `my_wsi.json` specifying the WSI to be processed.

```bash
eats jobs register $APP_ID eats_inputs/ --job-mode preprocessing > job.env
```

Export the `APP_ID` with:

```bash
export $(xargs < job.env)
```

Start the preprocessing job:

```bash
eats jobs run job.env
```

Check the job status to ensure the job has finished and is in status `COMPLETED`.

The preprocessing job has generated a collection of polygon annotations as output. You can export and examine this output:

```bash
export $(xargs < job.env)
# wait for job to complete
eats jobs wait $EMPAIA_JOB_ID
# export job outputs
eats jobs export $EMPAIA_JOB_ID ./job-outputs
less ./job-outputs/my_cells.json
```

The exported collection in `my_cells.json` should be one of the inputs for a containerized postprocessing job. However, the exported output is not directly usable as input for another job, because certain properties are not part of data models for the creation of new data. Nevertheless, the output in `my_cells.json` can be used as inputs for the containerized postprocessing.

## Register and Run Postprocessing Job

The postprocessing mode of the app requires three inputs: a single WSI, a single rectangle and a collection with items of type polygon. The inputs for the WSI (`my_wsi.json`) is the same as in the proprocessing job. The input rectangle (`my_rectangle.json`) is passed as usual. The input for the polygon collection (`my_cells`) should be the output generated by the preprocessing job. While registering the postprocessing job, we can pass the optional parameter `--preprocessing-job-id <id-of-preprocessing-job>` to specify a preprocessing job whose outputs should be used as inputs. The input file `my_cells.json` now only must contains the key name of the output from the preprocessing mode:

```JSON
{
    "output_key": "my_cells"
}
```

When the job is registered it will be check if the output specified in `my_cells.json` is valid in the EAD and was created by the job specified with `--preprocessing-job-id <id-of-preprocessing-job>`. The `APP_ID` of the specified preprocessing job must match the `APP_ID` when registering a postprocessing job. The command to register the containerized postprocessing job is:

```bash
eats jobs register $APP_ID eats_inputs/ --job-mode postprocessing --preprocessing-job-id $EMPAIA_JOB_ID > job.env
```
